# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/network/rocketmq_proxy/v4alpha/rocketmq_proxy.proto, envoy/extensions/filters/network/rocketmq_proxy/v4alpha/route.proto
# plugin: python-betterproto
from dataclasses import dataclass
from datetime import timedelta
from typing import List

import betterproto
from betterproto.grpc.grpclib_server import ServiceBase


@dataclass(eq=False, repr=False)
class RouteConfiguration(betterproto.Message):
    # The name of the route configuration.
    name: str = betterproto.string_field(1)
    # The list of routes that will be matched, in order, against incoming
    # requests. The first route that matches will be used.
    routes: List["Route"] = betterproto.message_field(2)


@dataclass(eq=False, repr=False)
class Route(betterproto.Message):
    # Route matching parameters.
    match: "RouteMatch" = betterproto.message_field(1)
    # Route request to some upstream cluster.
    route: "RouteAction" = betterproto.message_field(2)


@dataclass(eq=False, repr=False)
class RouteMatch(betterproto.Message):
    # The name of the topic.
    topic: "_____type_matcher_v4_alpha__.StringMatcher" = betterproto.message_field(1)
    # Specifies a set of headers that the route should match on. The router will
    # check the request’s headers against all the specified headers in the route
    # config. A match will happen if all the headers in the route are present in
    # the request with the same values (or based on presence if the value field
    # is not in the config).
    headers: List[
        "_____config_route_v4_alpha__.HeaderMatcher"
    ] = betterproto.message_field(2)


@dataclass(eq=False, repr=False)
class RouteAction(betterproto.Message):
    # Indicates the upstream cluster to which the request should be routed.
    cluster: str = betterproto.string_field(1)
    # Optional endpoint metadata match criteria used by the subset load balancer.
    metadata_match: "_____config_core_v4_alpha__.Metadata" = betterproto.message_field(
        2
    )


@dataclass(eq=False, repr=False)
class RocketmqProxy(betterproto.Message):
    # The human readable prefix to use when emitting statistics.
    stat_prefix: str = betterproto.string_field(1)
    # The route table for the connection manager is specified in this property.
    route_config: "RouteConfiguration" = betterproto.message_field(2)
    # The largest duration transient object expected to live, more than 10s is
    # recommended.
    transient_object_life_span: timedelta = betterproto.message_field(3)
    # If develop_mode is enabled, this proxy plugin may work without dedicated
    # traffic intercepting facility without considering backward compatibility of
    # exiting RocketMQ client SDK.
    develop_mode: bool = betterproto.bool_field(4)


from ......config.core import v4alpha as _____config_core_v4_alpha__
from ......config.route import v4alpha as _____config_route_v4_alpha__
from ......type.matcher import v4alpha as _____type_matcher_v4_alpha__
